﻿local allMenu = "Menu MainMenu UserMenu Disks "
local Completion = "ShellAutoCompletion DialogAutoCompletion "
local allDlgs = "Dialog "..allMenu..Completion
local set,lock,notempty = 0,1,2 -- first arg of Menu.Filter()

local F = far.Flags
--------------------------------------
-- Smart shortcuts during filtering --

local lasthot
Macro { description="Menu filter: smart shortcuts";
  area=allMenu; key="/^.$/"; priority=30; --for combobox: area="Dialog "..allMenu / MenuOrList()
  condition=function() return Menu.Filter(set)==1 end;
  action=function()
    local s = Menu.FilterStr()
    local ch = akey(1)
    local hot = Object.CheckHotkey(ch)>0
    if ch==s:sub(-1,-1) and (hot or ch==lasthot) then
      Keys("BS","Alt"..ch)
      lasthot = false
    else
      if hot then lasthot = ch else lasthot = false end
      Keys "AKey"
    end 
  end;
}

-----------------------------------
-- Non-modal menu filter via Alt --

local expanded = 0x8000
local function MenuOrList()
  return not Area.Dialog or Dlg.ItemType==F.DI_LISTBOX 
                         or Dlg.ItemType==F.DI_COMBOBOX+expanded
end

local x = {['ShiftBackSlash']="|"}
for k,v in ([[`~ 1! 2@ 3# 4$ 5% 6^ 7& 8* 9( 0) -_ =+ [{ ]} ;: '" ,< .> /?]])
           :gmatch("([%S])([%S])") do
  x["Shift"..k] = v
end

local rus = 0x04190419
Macro { description="Menu filter: non-modal [Alt-<key>]";
  area=allDlgs; condition=MenuOrList; priority=30;
  key="/^[RL]Alt(BS|Add|Subtract|Multiply|Divide|BackSlash|ShiftBackSlash|.|Shift.)$/";
  action=function()
    local key = akey(1):match("R?Alt(.+)")
    Menu.Filter(lock,0)
    Menu.Filter(set,1)
    key = x[key] or key
    if key:len()==1 and Far.KbdLayout()==rus then key=mf.xlat(key) end
    Keys(key)
    Menu.Filter(lock,1)
  end;
}

--------------------------
-- Additional shortcuts --

Macro { description="Menu filter: toggle Lock [CtrlAltL]";
  area=allDlgs; condition=MenuOrList; key="LAlt"; priority=30;
  action=function()
    Menu.Filter(lock,1-Menu.Filter(lock))
  end;
}

Macro { description="Menu filter: xlat";
  area=allDlgs; key="CtrlAltBS"; priority=30;
  condition=function() return MenuOrList() and Menu.FilterStr() end;
  action=function()
    Menu.FilterStr(1,mf.xlat(Menu.FilterStr(),0x1))
  end;
}
